            #GIT_CMT=727c537208b1d42f919abc1febe64999176f080f
%define pname oracle-database-preinstall
%define dbrel 23ai
%define prevdbrel 23c
%define configdir /etc/sysconfig
%define logdir /var/log
%define version 1.0
%define release 3%{dist}
%define name %{pname}-%{dbrel}
%global debug_package %{nil}

Summary: Oracle Database Preinstallation RPM
Name: %{name}
Version: %{version}
Release:    3.el9
License: GPLv2
Vendor: Oracle
Source: oracle-database-preinstall-1.0.tar.bz2
Provides: %{name} = %{version}

Conflicts: exadata-base
Obsoletes: %{pname}-%{prevdbrel}
Requires(pre): /etc/redhat-release 
%ifarch x86_64
Requires: bc >= 1.07.1
Requires: binutils >= 2.35.2
Requires: fontconfig >= 2.14.0
Requires: glibc >= 2.34
Requires: glibc-devel >= 2.34
Requires: libaio >= 0.3.111
Requires: libgcc >= 11.3.1
Requires: libstdc++ >= 11.3.1
Requires: make >= 4.3
Requires: net-tools >= 2.0
Requires: nfs-utils >= 2.5.4
Requires: rpmlib(CompressedFileNames) <= 3.0.4-1
Requires: rpmlib(FileDigests) <= 4.6.0-1
Requires: rpmlib(PayloadFilesHavePrefix) <= 4.0-1
Requires: rpmlib(PayloadIsXz) <= 5.2-1
Requires: smartmontools >= 7.2
Requires: sysstat >= 12.5.4
%endif
%ifarch aarch64
Requires: bc
Requires: binutils
Requires: fontconfig
Requires: glibc
Requires: glibc-devel
Requires: libaio
Requires: libgcc
Requires: libstdc++
Requires: make
Requires: net-tools
Requires: nfs-utils
Requires: rpmlib(CompressedFileNames)
Requires: rpmlib(FileDigests)
Requires: rpmlib(PayloadFilesHavePrefix)
Requires: rpmlib(PayloadIsXz)
Requires: smartmontools
Requires: sysstat
%endif

Requires: bind-utils ethtool initscripts ksh module-init-tools 
Requires: openssh-clients pam procps psmisc tar
Requires: unzip util-linux-ng xorg-x11-utils xorg-x11-xauth 
%if 0%{?el7}
Requires: policycoreutils-python
%endif
%if 0%{?el8}
Requires: compat-openssl10 policycoreutils policycoreutils-python-utils
%endif
%if 0%{?el9}
#Removed compat-openssl10 for OL9 due to non-availability
#Requires: libnsl >= 2.34
Requires: compat-openssl11 grub2-tools 
Requires: libxcrypt-compat >= 4.4.18
Requires: policycoreutils policycoreutils-python-utils
%endif

BuildRequires: bash
BuildRoot: %{_builddir}/%{pname}-%{version}-root

%description
The Oracle Database Preinstallation RPM automatically installs any additional
packages needed for installing Oracle Grid Infrastructure and Oracle Database
and configures your server operating system automatically, including setting
kernel parameters and other basic operating system requirements for install.

%prep
%setup -q -n %{pname}-%{version}

%build

%install 
mkdir -p -m 755 $RPM_BUILD_ROOT/usr/bin
mkdir -p -m 755 $RPM_BUILD_ROOT/etc/systemd/system
mkdir -p -m 755 $RPM_BUILD_ROOT/etc/security/limits.d
mkdir -p -m 755 $RPM_BUILD_ROOT/%{configdir}/%{name}
mkdir -p -m 700 $RPM_BUILD_ROOT/%{logdir}/%{name}/results
install -m 700 %{pname}-verify $RPM_BUILD_ROOT/%{configdir}/%{name}/%{name}-verify
install -m 700 %{pname}-verify $RPM_BUILD_ROOT/usr/bin/%{name}-verify 
install -m 600 %{pname}.param $RPM_BUILD_ROOT/%{configdir}/%{name}/%{name}.param
cat %{pname}-%{dbrel}.param >> $RPM_BUILD_ROOT/%{configdir}/%{name}/%{name}.param
install -m 700 %{pname}-firstboot $RPM_BUILD_ROOT/%{configdir}/%{name}/%{name}-firstboot
install -m 700 %{pname}-firstboot.service $RPM_BUILD_ROOT/etc/systemd/system/%{name}-firstboot.service
touch $RPM_BUILD_ROOT/etc/security/limits.d/%{name}.conf
ln -f -s %{configdir}/%{name}/%{name}-verify $RPM_BUILD_ROOT/usr/bin/%{name}-verify 
sed -i s/%{pname}/%{name}/g $RPM_BUILD_ROOT/%{configdir}/%{name}/%{name}-firstboot
sed -i s/%{pname}/%{name}/g $RPM_BUILD_ROOT/etc/systemd/system/%{name}-firstboot.service
sed -i s/%{pname}/%{name}/g $RPM_BUILD_ROOT/%{configdir}/%{name}/%{name}.param

%clean 
rm -rf $RPM_BUILD_ROOT

%define prescript()  \
if [ -f %{configdir}/%{pname}-%1/%{pname}-%1.param ]; then  \
  cp -f %{configdir}/%{pname}-%1/%{pname}-%1.param %{logdir}/%{pname}-%1/results/.%{pname}-%1.param; \
fi; 

%define preunscript()  \
if [ "$1" = "0" ] ; then \
 if ! [ -f %{configdir}/%{pname}-%1/%{pname}-%1.conf ]; then \
   systemctl disable %{name}-firstboot.service \
 fi; \
 if [ -x /usr/bin/%{pname}-%1-verify ]; then \
   /usr/bin/%{pname}-%1-verify -u 2> /dev/null 1>&2; \
 fi; \
fi;

%define posttransscript()  \
/usr/bin/%{pname}-%1-verify 2>/dev/null 1>&2; \
if ! [ -f %{configdir}/%{pname}-%1/%{pname}-%1.conf ]; then \
 systemctl enable %{pname}-%1-firstboot.service \
fi;

%define postunscript()  \
if [ "$1" = "0" ] ; then \
 if [ -d %{configdir}/%{pname}-%1 ]; then \
   rm -rf %{configdir}/%{pname}-%1; \
 fi; \
 if [ -d %{logdir}/%{pname}-%1 ]; then  \
   rm -rf %{logdir}/%{pname}-%1; \
 fi; \
fi;

#%pre
#%{expand:%%prescript %{dbrel}}

%preun
%{expand:%%preunscript %{dbrel}}

%posttrans
%{expand:%%posttransscript %{dbrel}}

%postun
%{expand:%%postunscript %{dbrel}}

%files
%defattr(-,root,root)
%license LICENSE
%config %{configdir}/%{name}/%{name}.param
%ghost /etc/security/limits.d/%{name}.conf
%{configdir}/%{name}
/etc/systemd/system/%{name}-firstboot.service
%{configdir}/%{name}/%{name}-verify
%{logdir}/%{name}
/usr/bin/%{name}-verify

%changelog
* Tue Oct 29 2024 Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-3.el9]
 - Add minimum versions for the dependencies [Orabug: 37001837]
 - Remove libnsl2 from dependencies [Orabug: 35448960]
 - Remove ethtool from dependencies [Orabug: 37227174]
 - Add compat-openssl11 to dependencies [Orabug: 37236140]

* Wed Apr 17 2024 Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-2.el9]
 - Use grubby to set boot parameters [Orabug: 36486171]
 - Do not set /etc/sysconfig/network parameter for Oracle 23 and 19 versions [Orabug: 36454150]
 - Fix verify script errors [Orabug: 36454150]
 - Change rpm name to 23ai [Orabug: 36432382]
 - Add grub2-tools to dependencies and use correct options for grub2-mkconfig [Orabug: 36397795]
 - Add libxcrypt-compat to the dependencies [Orabug: 36345689]
 - Set transparent_hugepage to madvise [Orabug: 36378470]
 - Add fontconfig to dependencies [Orabug: 36378986]
 - Add kernel.panic to sysctl parameters [Orabug: 36379000]
 - Set ip_local_port_range to odd/even polarity [Orabug: 36387385]
 - Add systemd file for firstboot [Orabug: 36366856]
 - Removed compat-openssl10 from dependencies 
 - Initial version
